aboutsummaryrefslogtreecommitdiff
path: root/scripts/kconfig/lxdialog/check-lxdialog.sh
diff options
context:
space:
mode:
authorSam Ravnborg <sam@mars.ravnborg.org>2006-01-21 12:03:09 +0100
committerSam Ravnborg <sam@mars.ravnborg.org>2006-01-21 12:03:09 +0100
commit3835f82183eab8b67ddda6b32c127859a546c82d (patch)
tree25d3e5179e13548b034213c54ed0a17db448e9b2 /scripts/kconfig/lxdialog/check-lxdialog.sh
parent3ee68c4af3fd7228c1be63254b9f884614f9ebb2 (diff)
kconfig: fix /dev/null breakage
While running "make menuconfig" and "make mrproper" some people experienced that /dev/null suddenly changed permissions or suddenly became a regular file. The main reason was that /dev/null was used as output to gcc in the check-lxdialog.sh script and gcc did some strange things with the output file; in this case /dev/null when it errorred out. Following patch implements a suggestion from Bryan O'Sullivan <bos@serpentine.com> to use gcc -print-file-name=libxxx.so. Also the Makefile is adjusted to not resolve value of HOST_EXTRACFLAGS and HOST_LOADLIBES until they are actually used. This prevents us from calling gcc when running make *clean/mrproper Thanks to Eyal Lebedinsky <eyal@eyal.emu.id.au> and Jean Delvare <khali@linux-fr.org> for the first error reports. Signed-off-by: Sam Ravnborg <sam@ravnborg.org> ---
Diffstat (limited to 'scripts/kconfig/lxdialog/check-lxdialog.sh')
-rw-r--r--scripts/kconfig/lxdialog/check-lxdialog.sh14
1 files changed, 9 insertions, 5 deletions
diff --git a/scripts/kconfig/lxdialog/check-lxdialog.sh b/scripts/kconfig/lxdialog/check-lxdialog.sh
index 448e353923f..120d624e672 100644
--- a/scripts/kconfig/lxdialog/check-lxdialog.sh
+++ b/scripts/kconfig/lxdialog/check-lxdialog.sh
@@ -4,17 +4,17 @@
# What library to link
ldflags()
{
- echo "main() {}" | $cc -lncursesw -xc - -o /dev/null 2> /dev/null
+ $cc -print-file-name=libncursesw.so | grep -q /
if [ $? -eq 0 ]; then
echo '-lncursesw'
exit
fi
- echo "main() {}" | $cc -lncurses -xc - -o /dev/null 2> /dev/null
+ $cc -print-file-name=libncurses.so | grep -q /
if [ $? -eq 0 ]; then
echo '-lncurses'
exit
fi
- echo "main() {}" | $cc -lcurses -xc - -o /dev/null 2> /dev/null
+ $cc -print-file-name=libcurses.so | grep -q /
if [ $? -eq 0 ]; then
echo '-lcurses'
exit
@@ -36,10 +36,13 @@ ccflags()
fi
}
-compiler=""
+# Temp file, try to clean up after us
+tmp=.lxdialog.tmp
+trap "rm -f $tmp" 0 1 2 3 15
+
# Check if we can link to ncurses
check() {
- echo "main() {}" | $cc -xc - -o /dev/null 2> /dev/null
+ echo "main() {}" | $cc -xc - -o $tmp 2> /dev/null
if [ $? != 0 ]; then
echo " *** Unable to find the ncurses libraries." 1>&2
echo " *** make menuconfig require the ncurses libraries" 1>&2
@@ -59,6 +62,7 @@ if [ $# == 0 ]; then
exit 1
fi
+cc=""
case "$1" in
"-check")
shift